package com.wd.workoffice.presenter;

import com.wd.workoffice.app.BaseBean;
import com.wd.workoffice.contract.ForgetOneContract;
import com.wd.workoffice.model.ForgetOneModel;
import com.wd.workoffice.retrofit.WorkObserver;

import flexible.xd.android_base.mvpBase.BasePresenter;
import flexible.xd.android_base.network.rtfhttp.Transformer;
import io.reactivex.disposables.Disposable;

/**
 * author : flexible
 * email : lgd19940421@163.com
 * github: https://github.com/FlexibleXd
 **/
public class ForgetOnePresenter extends BasePresenter<ForgetOneContract.View, ForgetOneContract.Model>  implements ForgetOneContract.Presenter {
    @Override
    public ForgetOneContract.Model bindModel() {
        return ForgetOneModel.newInstance();
    }

    @Override
    public void getCode(String phone, String type) {
        mView.showLoading();
        mModel.getCode(phone, type).compose(Transformer.schedule()).subscribe(new WorkObserver<BaseBean>() {
            @Override
            public void doOnSubscribe(Disposable d) {
                mDisposable.add(d);
            }

            @Override
            public void onFail(String errorMsg) {
                mView.hideLoading();
                mView.onError(errorMsg);
            }

            @Override
            public void onSuccess(BaseBean data) {
                mView.hideLoading();
                if (data.getCode() != 0) {
                    mView.onError(data.getMessage());
                    return;
                }
                mView.codeSuccess();
            }
        });
    }

    @Override
    public void verifyCode(String phone, String verifyCode, String type) {
        mView.showLoading();
        mModel.verifyCode(phone, verifyCode,type).compose(Transformer.schedule()).subscribe(new WorkObserver<BaseBean>() {
            @Override
            public void doOnSubscribe(Disposable d) {
                mDisposable.add(d);
            }

            @Override
            public void onFail(String errorMsg) {
                mView.hideLoading();
                mView.onError(errorMsg);
            }

            @Override
            public void onSuccess(BaseBean data) {
                mView.hideLoading();
                if (data.getCode() != 0) {
                    mView.onError(data.getMessage());
                    return;
                }
                mView.verifySuccess();
            }
        });
    }
}
